> ## Documentation Index
> Fetch the complete documentation index at: https://developers.kulmipay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List wallet transactions

> Retrieve wallet transaction history.



## OpenAPI

````yaml /openapi.yml get /wallets/{id}/transactions
openapi: 3.0.0
info:
  title: KulmiPay API
  description: >-
    Public API reference for KulmiPay collections, Send Money, wallets, refunds,
    and M-Pesa account configuration.
  version: 1.0.0
servers:
  - url: https://sandbox.kulmipay.com/api/v1
    description: Sandbox
  - url: https://app.kulmipay.com/api/v1
    description: Live
security:
  - SecretAPIKeyScheme: []
tags:
  - name: Collections
    description: >-
      Create hosted checkout sessions, M-Pesa STK Push requests, and payment
      status checks.
  - name: Send Money
    description: Initiate, approve, cancel, and track payout files.
  - name: Wallet as a Service
    description: Manage wallets, statements, wallet funding, and internal transfers.
  - name: Refunds
    description: Create and retrieve refund requests through the chargebacks API.
  - name: Bring Your M-Pesa Till/PayBill Number
    description: Configure M-Pesa Till and PayBill accounts.
  - name: Webhooks
    description: Retrieve webhook configuration and delivery events.
paths:
  /wallets/{id}/transactions:
    parameters:
      - name: id
        in: path
        description: A unique integer value identifying this wallet.
        required: true
        schema:
          type: integer
    get:
      tags:
        - Wallet as a Service
      summary: List wallet transactions
      description: Retrieve wallet transaction history.
      operationId: wallets_transactions
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionSer'
components:
  schemas:
    TransactionSer:
      required:
        - invoice
      type: object
      properties:
        transaction_id:
          title: Transaction id
          type: string
          readOnly: true
        invoice:
          $ref: '#/components/schemas/InvoicesSer'
        currency:
          title: Currency
          type: string
          readOnly: true
        value:
          title: Value
          type: string
          format: decimal
          readOnly: true
        running_balance:
          title: Running balance
          type: string
          format: decimal
          readOnly: true
        narrative:
          title: Narrative
          type: string
          nullable: true
        trans_type:
          title: Trans type
          type: string
          enum:
            - SALE
            - ADJUSTMENT
            - PAYOUT
            - CHARGE
            - AIRTIME
            - DEPOSIT
            - EXCHANGE
            - UNMARKED
        status:
          title: Status
          type: string
          enum:
            - AVAILABLE
            - CLEARING
            - ON-HOLD
            - CANCELLED
            - CHARGEBACK-PENDING
            - REFUNDED
            - ADJUSTMENT
        created_at:
          title: Created at
          type: string
          format: date-time
          readOnly: true
          nullable: true
        updated_at:
          title: Updated at
          type: string
          format: date-time
          readOnly: true
          nullable: true
    InvoicesSer:
      required:
        - provider
        - value
      type: object
      properties:
        invoice_id:
          title: Invoice id
          type: string
          readOnly: true
        state:
          title: State
          type: string
          enum:
            - PENDING
            - PROCESSING
            - FAILED
            - CANCELED
            - PARTIAL
            - COMPLETE
            - RETRY
        provider:
          title: Provider
          type: string
          enum:
            - M-PESA
            - PESALINK
        charges:
          title: Charges
          type: string
          format: decimal
        net_amount:
          title: Net amount
          type: string
          readOnly: true
        currency:
          title: Currency
          type: string
          readOnly: true
        value:
          title: Value
          type: string
          format: decimal
        account:
          title: Account
          description: Depositing account, email or phone number
          type: string
          maxLength: 140
          nullable: true
        api_ref:
          title: Api ref
          description: API tracking reference number
          type: string
          pattern: ^[a-zA-Z0-9-_ ]+$
          maxLength: 140
          nullable: true
        clearing_status:
          title: Clearing status
          type: string
          readOnly: true
        mpesa_reference:
          title: Mpesa reference
          type: string
          readOnly: true
        host:
          title: Host
          description: Payment origin host i.e domain making the payment
          type: string
          pattern: ^[a-zA-Z0-9-_./=:?# ]+$
          maxLength: 200
          nullable: true
        retry_count:
          title: Retry count
          type: integer
          maximum: 2147483647
          minimum: -2147483648
        failed_reason:
          title: Failed reason
          type: string
          nullable: true
        failed_code:
          title: Failed code
          type: string
          maxLength: 45
          nullable: true
        failed_code_link:
          title: Failed code link
          type: string
          readOnly: true
        created_at:
          title: Created at
          type: string
          format: date-time
          readOnly: true
          nullable: true
        updated_at:
          title: Updated at
          type: string
          format: date-time
          readOnly: true
          nullable: true
  securitySchemes:
    SecretAPIKeyScheme:
      type: http
      scheme: bearer
      description: Use your KulmiPay secret key as the Bearer token.
      x-default: ISSecretKey_test_xxxxxxxxxxxxxxxx

````